#ifndef IBN_GUI_UTILS_H
#define IBN_GUI_UTILS_H
#include <string>

#include <sstream>
//#include "data/Data.h"
#include <iostream>
#include <iomanip>

/*
template <class T> std::string setString( T  t, unsigned w=9 , unsigned prec = 8);
template <class T> void getData(const char * str, T &t);
template <class T> T getData(const char *str);
template <class T> T getData(std::string strin);
//       data::PhysValue
void operator<<(data::PhysValue a, std::string& s);
void operator<<(std::string& s, data::PhysValue a);
*/



template <class T> std::string setString( T  t, unsigned w=0 , unsigned prec = 14)
{
	std::ostringstream ostr;
	ostr.setf(std::ios::left);
	ostr <<  std::setw(w) << std::setprecision(prec) << t;// << std::ends;
	std::string s = ostr.str();
	//delete ostr.str();
	return s;
}

template <class T> void getData(const char * str, T &t)	
{
	std::istringstream istr(str);
	istr >> t;
}

template <class T> T getData(const char *str)
{
	std::istringstream istr(str);
	T data;
	istr >> data;
	//delete istr.str();
	return data;
}


template <class T> T getData(std::string strin)
{
	const char* str=strin.c_str();
	std::istringstream istr(str);
	T data;
	istr >> data;
	return data;
}





#endif
