#ifndef SMV_INVENTORY_H
#define SMV_INVENTORY_H

#include <string>
namespace camac
{
  class ModuleInventory
  {
    public:
      virtual ~ModuleInventory(void){}

      ModuleInventory(std::string nm, std::string t, std::string subt)
      {
        Name=nm;
        Type=t;
        SubType=subt;
      }

      ModuleInventory(void)
      {
      }

      const char* GetName(void)const {return Name.c_str();}
      const char* GetType(void)const {return Type.c_str();}
      const char* GetSubType(void)const {return SubType.c_str();}

			void SetSubType(const char * subtype)
			{
				SubType = subtype;
			}

      inline void CheckX(bool b=true) { check_X = b ; }
    protected:
      bool check_X; //check X answer
    private:
      std::string Name="unknown"; //block name
      std::string Type="unknown"; //block type
      std::string SubType="unknown"; //block subtype
  };
}

#endif
