#ifndef IBN_GUI_COUNTER_DIALOG_H
#define IBN_GUI_COUNTER_DIALOG_H

#include <string>

#include <TGFrame.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <TGLabel.h>
#include "../measurement/Manager.h"

#include <TGButton.h>
#include <TGMenu.h>
#include <TGNumberEntry.h>

#include <TGLabel.h>

#include <TGFrame.h>
#include "TH1.h"


namespace gui
{
		typedef std::map<unsigned, TGTextButton *> bmap_t;
		enum TEXTENTRY { VVI, THRESHOLD };
		enum BUTTONS { ONOFF, RESET };




//========================================================================
//   .     :    ,  
//     .     ,     
//  ,    100% 
		
		class CounterDialog : public TGTransientFrame {//TGMainFrame {
        public:
            CounterDialog(const TGWindow *, measurement::Manager *);
            ~CounterDialog(void);
            Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
            void CloseWindow(void);
        private:
            bool ismeasure;
//						TGWindow * MainWindows; 
						measurement::Manager  *polarimeter;
 ///           typedef std::map<unsigned, TGTextButton *> bmap_t;
            bmap_t b;
            TGLayoutHints * b_layout;
            void LockButton(unsigned);
            void UnLockButton(void);
            /* menus */
  ///          TGMenuBar *MenuBar;
            /* here is all options for control but i doubt about GraphicsMenu */
  ///          TGPopupMenu	*FileMenu, *WindowMenu, *SettingsMenu, *OptionsMenu, *HelpMenu;
    ///        TGLayoutHints * MenuBarItemLayout, * MenuBarLayout; 
		/* vidget ids */
    };

//========================================================================












		
    class CounterCalibrate_by_Landao_Dialog : public TGTransientFrame
      {
        public:
            CounterCalibrate_by_Landao_Dialog(const TGWindow * w, measurement::CounterCalibrate_by_Landao*);
            ~CounterCalibrate_by_Landao_Dialog(void);
            Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
           // void GetData(data::MeasurementConfig *) const;
           // void SetData(const data::MeasurementConfig *);
        private:
						friend void* LanadaoDistributionGraphicView_in_thread(void*);
						
        		TH1F *Counter_calibr_landao_histogram;
            TGLayoutHints * nel;
            TGNumberEntry* counter_num, *delay, *threshold, *voltage;//my
            TGLabel *counter_num_l, *delay_l, *threshold_l, *voltage_l;//my
						
						TGHorizontalFrame *counter_num_f, *delay_f, *threshold_f, *voltage_f;//my
            
						measurement::CounterCalibrate_by_Landao* CounterCalibr;//class from Manager responsing for counters calibrate 

            
           // FrequencyEnergyFrame * fe;
           // data::MeasurementConfig  *cfg;
            TGLayoutHints *lf,*lr,*ll;

            TGLayoutHints *bl;
            TGHorizontalFrame * bf;
            std::vector<std::string> b_name;
            std::vector<TGTextButton*> b;
						pthread_t landao_view_thread;
    };

//=======================================================================
	
//========================================================================
/*
    class CounterCalibrate_by_ClassicMethod_Dialog : public TGTransientFrame     {
        public:
            CounterCalibrate_by_ClassicMethod_Dialog(const TGWindow * w, measurement::CounterCalibrate_by_ClassicMethod*);
            ~CounterCalibrate_by_ClassicMethod_Dialog(void);
            Bool_t ProcessMessage(Long_t msg, Long_t parm1, Long_t parm2 );
           // void GetData(data::MeasurementConfig *) const;
           // void SetData(const data::MeasurementConfig *);
        private:
        		
						measurement::CounterCalibrate_by_ClassicMethod* CounterCalibrate;
						//TH1F *Counter_calibr_landao_histogram;
            TGLayoutHints * nel;
            TGNumberEntry* counter_num, *volt_begin, *volt_end, *count_time;//my
            TGLabel *counter_num_l, *volt_begin_l, *volt_end_l, *count_time_l;//my
						
						TGHorizontalFrame *counter_num_f, *volt_begin_f, *volt_end_f, *count_time_f;
            

            
           // FrequencyEnergyFrame * fe;
           // data::MeasurementConfig  *cfg;
            TGLayoutHints *lf,*lr,*ll;

            TGLayoutHints *bl;
            TGHorizontalFrame * bf;
            std::vector<std::string> b_name;
            std::vector<TGTextButton*> b;
            int * retval;
						pthread_t landao_view_thread;
    };

//=======================================================================

		
//=======================================================================
//      CounterCalibrate_by_ClassicMethod ,  
//     CounterCalibrate_by_ClassicMethod_Dialog.
//  , !!!
//   !!!
struct CounterCalibr_Calssic_begin_data
	{
	measurement::EnergyCalibrationCamac ECCamac;
	unsigned counter_num, volt_begin, volt_end, count_time;
	};
		
		
		
	*/	
		
		
		
		
		
		
}
#endif
