#ifndef SMV_CAMAC_DEPOLARIZERCAMAC_H
#define SMV_CAMAC_DEPOLARIZERCAMAC_H
#include "../camac/Module.h"
#include "../camac/Generator.h"
#include "../camac/ModuleInventory.h"
#include "MeasurementCamac.h"





namespace camac
{
	class DepolarizerCamac : MeasurementCamac
	{
		public:
			DepolarizerCamac(void);
			~DepolarizerCamac(void);

			void SetTimeGenerater(double);
			void GenerateFrequency(double);
			//	std::list<Module*> GetModuleList(void);

			std::list<ModuleInventory*> *GetModuleList(void){return &ModuleList;}
		private:
			std::list<ModuleInventory* > ModuleList; //Список БЛОКОВ, который передается в Config
			Generator_DDS300* Generater;
	};
}


#endif //CAMAC_DEPOLARIZERCAMAC_SMV_H
