#include<camac/Module.h>

#include<iostream>
#include<cstdio>
//#include<getopt.h>

int main(int argc, char ** argv)    {
	int interface = -1;
	int crate = -1;
	int station = -1;

         int c;
         int digit_optind = 0;

		 if(argc < 2) {
			 cout << "Program test work of camac module" << endl;
			 cout << "Writen by Ivan B. Nikolaev, 39-41-78 28 NOV 2001" << endl;
			 cout << "Usege: " << argv[0] << " interface/crate/station [option [parameter]]" << endl;
			 cout << "Option is" << endl <<
				 "--af a f data: af instruction " << endl;

             exit(0);
		 }
         sscanf(argv[1],"%d/%d/%d",&interface,&crate,&station);
		 try    {
			 camac::Module mdl("Module",camac::Address("Module",interface,crate,station));

		 while (1)	{
             int this_option_optind = optind ? optind : 1;
             int option_index = 0;
             static struct option long_options[] =
             {
			   {"af",1,0,'a'},
			   {0,0,0,0}
             };

			 c = getopt_long (argc, argv, "a:",long_options, &option_index);
			 if (c == -1)	break;

             unsigned a,f,data;
			 switch (c)	{
				 case 'a':
				   sscanf(optarg,"%u/%u/%x",&a,&f,&data);
				   mdl.AF(a,f,&data);
				   cout << "0x"<< data <<endl;
				   cout << "bin: ";
				   for(int i=7; i>=0; i--)    {
                    cout << (data >> i & 0x1);
				   }
                   cout << endl;
				   break;
				 case '?':
                 break;

               default:
                 printf ("?? getopt returned character code 0%o ??\n", c);
               }
            }

         if (optind < argc-1)
           {
             printf ("non-option ARGV-elements: ");
             while (optind < argc)
             printf ("%s ", argv[optind++]);
             printf ("\n");
		   }

		 }
         catch(camac::system_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}

	catch(camac::station_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::logic_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::runtime_error e)    {
		cerr << "\n***** " << e.what() << endl;
	}
}
