//===================================================
//autor: Struchalin M.V.          17.09.2003
//===================================================
#include "../camac/Module.h"
#include <iostream>


int main(int argc, char **argv)
{

	try 
	{
		std::string adr;
int channel=0;
		if (argc == 2) 
		{
		adr=argv[1];
		std::string h1="--h", h2="--help";
	  if (adr==h1 || adr==h2 )
			{
				std::cout<<"====================\nAutor: Struchalin M.V\nProgramm work with Controll Magistral (bus write/read).\nFor work enter <<"<<argv[0]<<" interface:crate:station>>\n====================\n";
			return 0;
			}
    }
		else
		{
			std::cout << "====================\nEnter addres of block. Input parametrs is interface:crate:station\nFor more help use key --h\n====================\n";
		return 0;
		}
//std::string name = "ControlMagistral:";
std::string chan = ":0";
std::string sum =adr + chan;
const char* sum_str_c = sum.c_str();
camac::Address blockAddr(sum_str_c);
std::cout <<"interface = "<< blockAddr.interface<<"\n";
std::cout <<"crate = "<< blockAddr.crate<<"\n";
std::cout <<"station = "<< blockAddr.station<<"\n";
std::cout <<"channel = "<< blockAddr.channel<<"\n";

camac::Module block(blockAddr, "ControlMagistral","qqq","wwww");
std::cout<<"11111\n";
u32_t i=0 , data_out;
while(1)
{
block.AF(channel, 16, &i);
usleep(50000);
block.AF(channel,0 , &data_out);
if (i != data_out) {sleep(2); std::cout << "!!! Error !!! Read in block  "<< i << ", write  " << data_out << "\n"; }

for (i = 1 ; i <=16777216 ; i=i*2)
      {
      block.AF(channel, 16, &i);
      usleep(50000);
      block.AF(channel,0 , &data_out);
			std::cout << i << " / " << data_out <<"\n";
      if (i != data_out) 
         {
					 std::cout << "!!! Error !!! Read in block  "<< i << ", write  "<< data_out << "\n";
	 int k;
	 u16_t kk=0;
	 u32_t ii = i-1;
	 for (k=1 ; k<=3 ; ++k)
	    {
	    //cout << ii << endl;
	    block.AF(channel, 16, &ii);
	    usleep(100000);
	    block.AF(channel, 0, &kk);
	    usleep(100000);
	    }
	 }
			
      }//end of for
//   for (i =0 ; i<=3 ; ++i)
//	 {
std::cout << "Do C()\n";
   block.C();
	 sleep(1);
//	 }
	 
//   for (i =0 ; i<=3 ; ++i)
//	 {
	 std::cout << "Do Z()\n";
   block.Z();
	 sleep(1);
//	 }

//	 for (i=0 ; i <= 3 ; ++i)
//	    {
	 std::cout << "SetI\n";
			block.SetI();
//			if (block.GetI == 1) {cout << "There is I"<< endl;} else {cout << "There is not I"<< endl; }
			sleep(1);
			std::cout << "ClearI\n";
			block.ClearI();
			sleep(1);
//	    }
			std::cout << "Crate is tested\n";
        i = 0;
//while(!block.IsLam()) { sleep(1); }
}
	}//end of type

	catch(camac::Crate::Error e)
	{
		std::cerr << "\n camac error ***** " <<e.what() << "\n";
	}
	catch(camac::Module::Error e)
	{                                                                            
		std::cerr << "\nModule error " <<e.what() << "\n";                                       
	}
	catch(std::logic_error e)                                                   
	{                                                                            
		std::cerr << "\nLogic error " <<e.what() << "\n";                                           
	}
	catch(std::runtime_error e)                                                   
	{                                                                            
		std::cerr << "\nruntime error " <<e.what() << "\n";                                       
	}           
return 0;	
} //end of main
