
#include <iostream>
#include<camac/Commutator.h>

#include<getopt.h>
int main(int argc, char ** argv)    {
    int interface = -1;
	int crate = -1;
	int station = -1;
	int channel = -1;
    int out, in;
    int c;
    int digit_optind = 0;

	if(argc < 2) {
		cout << "Program test work of commutator KVCH LO403" << endl;
		cout << "Writen by Ivan B. Nikolaev, 39-41-78 29 NOV 2001" << endl;
		cout << "Usege: " << argv[0] << " interface/crate/station [option [parameter]]" << endl;
		cout << "Option is" << endl <<
			"--gettype :   " 			<< endl <<
			"--commutate out/in " 			<< endl <<
			"--get out" 			<< endl <<
			"--on" 			<< endl <<
			"--off" 			<< endl;

             exit(0);
	}
    sscanf(argv[1],"%d/%d/%d",&interface,&crate,&station);
	try    {
		camac::Commutator_LO403 com(camac::Address("commutator",interface,crate,station));
	while (1)	{
             int this_option_optind = optind ? optind : 1;
             int option_index = 0;
             static struct option long_options[] =
             {
			   {"gettype",0,0,'t'},
			   {"commutate",1,0,'c'},
			   {"get",1,0,'g'},
			   {"on",0,0,'o'},
			   {"off",0,0,'d'},
			   {0,0,0,0}
             };
			 c = getopt_long (argc, argv, "tc:g:od",long_options, &option_index);
			 if (c == -1)	break;

			 switch (c)	{
				 case 't':
					 cout << "# KVCH type is " << com.GetType() << endl;
                     break;
				 case 'c':
					 sscanf(optarg,"%d/%d",&in,&out);
					 cout << "# Commutate " << in << " with " << out << " " << flush;
                     com.Commutate(in,out);
					 cout << " [OK]" << endl;
					 break;
				 case 'g':
					 sscanf(optarg,"%d",&out);
					 cout << "# " << out << " commutate with " << com.GetCommutation(out);
					 cout << " [OK]" << endl;
					 break;
				 case 'o':
					 cout << "# tern on commutation" ;
					 com.On();
					 cout << " [OK]" << endl;
					 break;
				 case 'd':
                    cout << "# tern off commutation" ;
					 com.Off();
					 cout << " [OK]" << endl;
					 break;
				 case '?':
                 break;
               default:
                 printf ("?? getopt returned character code 0%o ??\n", c);
    		}
    }

    if (optind < argc-1)	{
             printf ("non-option ARGV-elements: ");
             while (optind < argc)
             printf ("%s ", argv[optind++]);
             printf ("\n");
	}

	}
    catch(camac::system_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}

	catch(camac::station_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::logic_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::runtime_error e)    {
		cerr << "\n***** " << e.what() << endl;
	}


	//cout << "  ,   " << endl << flush;

}

