#include<camac/Concurrence.h>

#include<iostream>
#include<cstdio>
#include<getopt.h>
#include<algorithm>

int main(int argc, char ** argv)    {
	int interface = -1;
	int crate = -1;
	int station = -1;
    int channel = -1;

         int c;
         int digit_optind = 0;

		 if(argc < 2) {
			 cout << "Program test work of camac module concurrency schime  with 10ms minimal step" << endl;
			 cout << "Writen by Ivan B. Nikolaev, 39-41-78 27 SEP 2001" << endl;
			 cout << "Usege: " << argv[0] << " interface/crate/station/channel [option [parameter]]" << endl;
			 cout << "Option is" << endl ;
             exit(0);
		 }
         sscanf(argv[1],"%d/%d/%d/%d",&interface,&crate,&station,&channel);
		 try    {
//		 		camac::Crate * Crate = new camac::Crate(interface,crate);
                camac::Vvi *Vvi=0;
				camac::Vvi *Vvi1=0;
				if(channel < 2) {
					camac::Address adr("Vvi", interface,crate,station,channel);
					Vvi = new camac::Vvi(adr);
				}
				else    {
                    camac::Address adr("Vvi", interface,crate,station,0);
					Vvi = new camac::Vvi(adr);
                    adr.channel=1;
					Vvi1 = new camac::Vvi(adr);
				}

		 while (1)	{
             int this_option_optind = optind ? optind : 1;
             int option_index = 0;
             static struct option long_options[] =
             {
			   {"on",0,0,0},
			   {"off",0,0,1},
			   {"reset",0,0,2},
			   {"set",1,0,3},
			   {"get",0,0,4}
             };

			 //c = getopt_long (argc, argv, "abcm:d:012",long_options, &option_index);
			 c = getopt_long (argc, argv, "",long_options, &option_index);
			 if (c == -1)	break;

			 unsigned volts=0;
             unsigned oldv=0;
             unsigned oldv1=0;
			 switch (c)	{
				 case 0:
					 cout << "# Tern on vvi " << flush;
					 if(!Vvi->IsOn())   {
						 Vvi->On();
						 if(Vvi1) {
						 	if(!Vvi1->IsOn())  {
                                Vvi1->On();
                             	sleep((27*max(Vvi->GetVolts(),Vvi1->GetVolts()))/1000);
						 	}
						 }
						 sleep((27*Vvi->GetVolts())/1000);
					 }
					 cout << " [OK]" << endl;
					 break;
                case 1:
					cout << "# Tern off vvi ";
					if(Vvi) Vvi->Off();
					if(Vvi1) Vvi1->Off();
					cout << " [OK]" << endl;
					 break;
				 case 2:
					 cout << "# Reset vvi ";
					 if(Vvi) Vvi->ResetOverload();
					 if(Vvi1) Vvi1->ResetOverload();
                 	 cout << " [OK]" << endl;
					 break;
				 case 3:
				   sscanf(optarg,"%u",&volts);
				   cout << "# Set volts to   " << volts << " V" <<flush;
                   oldv = Vvi->GetVolts();
                   if(Vvi1) oldv1 = Vvi1->GetVolts();
				   if(Vvi->IsOn()){
					   Vvi->SetVolts(volts);
					   if(Vvi1) {
					   		if(Vvi1->IsOn() ) {
								Vvi1->SetVolts(volts);
					        	if(volts>min(oldv,oldv1))  sleep((27*(volts-min(oldv,oldv1)))/1000);
                       			else sleep( ( max(oldv,oldv1) - volts ) / 1000 );
					   		}
					   		else {
								Vvi1->SetVolts(volts);
                                if(volts>oldv)  sleep(27*(volts-oldv)/1000);
                           		else sleep((oldv-volts)/1000);
					   		}
					   }
					   else {
						   if(volts>oldv)  sleep(27*(volts-oldv)/1000);
                           else sleep((oldv-volts)/1000);
					   }
				   }
				   else { Vvi->SetVolts(volts); };
                   cout << " [OK]" << endl;
				   break;
                 case 4:
					 cout << "# Get volts on vvi: ";
					 if(Vvi) cout << Vvi->GetVolts() << "V ";
					 if(Vvi1) cout << Vvi1->GetVolts() << "V ";
                 	 cout << " [OK]" << endl;
				 case '?':
                 break;


               default:
                 printf ("?? getopt returned character code 0%o ??\n", c);
               }
            }

         if (optind < argc-1)
           {
             printf ("non-option ARGV-elements: ");
             while (optind < argc)
             printf ("%s ", argv[optind++]);
             printf ("\n");
		   }

		 }
         catch(camac::system_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}

	catch(camac::station_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::logic_error e)    {
		cerr << "\n***** " <<e.what() << endl;
	}
	catch(std::runtime_error e)    {
		cerr << "\n***** " << e.what() << endl;
	}
}
