#pragma once
#include <memory>
#include <map>
#include <string>

#include <boost/property_tree/ptree.hpp>

#include "Log.h"
#include "Timer.h"
#include "Vvi.h"
#include "Delay.h"
#include "Diskr.h"
#include "Counter.h"
#include "Concur.h"
#include "Attenuator.h"
#include "Generator.h"
#include "Kvch.h"
#include "Freq.h"
namespace camac
{
	/* Get boost property tree and return map of the initialized camac modules */
	std::map <std::string,  std::shared_ptr<camac::ModuleInventory> > InitModules(boost::property_tree::ptree & tree, bool iscamac=true);
}
