#ifndef IBN_MEASUREMENT_DEFS_H
#define IBN_MEASUREMENT_DEFS_H
#include<valarray>
#include<iostream>
#include<iomanip>
#include"../Formula.h"
#include<vector>
#include<string>

namespace   measurement {
    template < class D > class Da
    class Result    {
	typedef double Value_t;
	typedef vector<Value_t> Vector_t
	public:
	    Result(void) {}
	    virtual ~Result(void){}

	    Value_t er(unsigned i)  const {
		if(i>=N) cerr << "bad data address " << endl;
		else return err[i];
		return 0;
	    }
	    Value_t *  V()  { return &val[0]; }
	    Value_t *  E()  { return &err[0]; }
	    valarray<Value_t>  er(void)  const { return err;}
	    void SetData(unsigned i, Value_t value, Value_t error)  {
		val[i] = value;
		err[i] = error;
	    }
	    void AddData(Value_t value, Value_t error)  {
		val[N] = value;
		err[N] = error;
		AddData();
	    }
	    virtual void AddData(void)	{
		if(N < val.size()) N++;
		else cerr << " e e " << endl;
	    }
	    virtual void SetSize(unsigned n) {
		N = 0;
		val.resize(n);
		err.resize(n);
	    }
	    unsigned GetN(void) const { return N; }
	    void SetN(unsigned n) { N = n;}
	    unsigned GetNmax(void) { return val.size();}
	protected:
	    unsigned N;
	    Vec_t val;
	    valarray<Value_t> err;
    };

    class Eat	{
	public:
	    Eat(void) {}
	    ~Eat(void) {}
    };

    inline istream & operator>> (istream & is, const Eat & eat)	{
	char ch;
	do is.get(ch);
	while(!isdigit(ch));
	is.putback(ch);
	return is;
    }



}// end of namespace measurement
#endif //IBN_MEASUREMENT_DEFS_H
