#ifndef IBN_DATA_STORAGE_H
#define IBN_DATA_STORAGE_H
/*
 * =====================================================================================
 * 
 *        Filename:  Storage.h
 * 
 *     Description:  Абсрактный класс для хранилищь данных по всем измерения с помощью поляриметра
 * 
 *         Version:  1.0
 *         Created:  23.07.2004 14:08:44 NOVST
 *        Revision:  none
 *        Compiler:  gcc
 * 
 *          Author:  Ivan Nikolaev ()
 *         Company:  BINP
 *           Email:  I.B.Nikolaev@inp.nsk.su
 * 
 * =====================================================================================
 */

namespace data
{

    class Storage 
    {
	public:
	    virtual ~Storage(void) {};
			virtual void Save(std::string) =0;
	    virtual void Load(std::string)=0;		
	    bool issave;
			static const int VERSION=12;
    };
}

#endif
