#!/bin/bash
#this script makes setup for compilation environment
#such as gcc, root,  boost

SETUP_FILE=setup.sh

#setup gcc 
echo 'export GCC_ROOT='$GCC_ROOT > $SETUP_FILE
echo 'export PATH=$GCC_ROOT/bin:$PATH' >> $SETUP_FILE
echo 'export LD_LIBRARY_PATH=$GCC_ROOT/lib:$LD_LIBRARY_PATH' >> $SETUP_FILE

#setup boost
echo 'export BOOST_ROOT='$BOOST_ROOT >> $SETUP_FILE
echo 'export LD_LIBRARY_PATH=$BOOST_ROOT/lib:$LD_LIBRARY_PATH' >> $SETUP_FILE


#setup root
echo 'export ROOTSYS='$ROOTSYS >> $SETUP_FILE
echo 'export PATH=$ROOTSYS/bin:$PATH' >> $SETUP_FILE
echo 'export LD_LIBRARY_PATH=$ROOTSYS/lib/root:$LD_LIBRARY_PATH' >> $SETUP_FILE

#setup xmlwrap
echo 'export XMLWRAPP_ROOT='$XMLWRAPP_ROOT >> $SETUP_FILE
echo 'export LD_LIBRARY_PATH=$XMLWRAPP_ROOT/lib:$LD_LIBRARY_PATH' >> $SETUP_FILE
