#ifndef IBN_MEASUREMENT_MEASUREMENT_H
#define IBN_MEASUREMENT_MEASUREMENT_H


#include <string>
#include "data/ConfigData.h"
#include "data/Storage.h"

namespace measurement
{

  class Measurement   
  {
    public:
      virtual ~Measurement(void){};
      virtual void Start(void)=0; //start measurement
      virtual void Start(std::string){}; //start measurement
      virtual void Stop(void)=0; //stop measurement
      virtual void Pause(void)=0; //pause measurement
      virtual void UnPause(void)=0; //continue paused measurement
      virtual void Continue(void)=0; // continue stopped measurement
			virtual bool IsMeasure(void) const =0; //IsMeasure
      virtual data::Storage* GetStorage(void) = 0;
  };


  //class MeasurementManager	
  //{
  //  public:
	//virtual ~MeasurementManager(void){};
  //    virtual void StopScan(void) = 0;
  //    virtual void StopMeasurement(void) = 0;
  //};
}
#endif
