LINUX_VERSION=`cat /etc/redhat-release`
if test "$LINUX_VERSION" = "Scientific Linux SL release 5.5 (Boron)" 
then
  export GCC_ROOT=/usr/local/gcc-4.9.0
  export PATH=$GCC_ROOT/bin:$PATH
  export LD_LIBRARY_PATH=$GCC_ROOT/lib:$LD_LIBRARY_PATH
  export BOOST_ROOT=/usr/local/boost-1.55.0/
  export LD_LIBRARY_PATH=$BOOST_ROOT/lib:$LD_LIBRARY_PATH
  export ROOTSYS=/usr/local/root-5.34
  export PATH=$ROOTSYS/bin:$PATH
  export LD_LIBRARY_PATH=$ROOTSYS/lib/root:$LD_LIBRARY_PATH
  export XMLWRAPP_ROOT=/opt/xmlwapp-0.6.3
  export LD_LIBRARY_PATH=$XMLWRAPP_ROOT/lib:$LD_LIBRARY_PATH
  export BOOST_ROOT=/usr/
  export GCC_ROOT=/usr/
else
  #workaround some centos7 bug in root system installation
  #it reqires libMultiProc.so* but unable to find it in common paths
  export ROOTSYS=/usr
  export PATH=$ROOTSYS/bin:$PATH
  export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/lib64/root
fi

