/*
 * =====================================================================================
 *
 *       Filename:  boost_fs.cpp
 *
 *    Description:  
 *
 *        Version:  1.0
 *        Created:  06/30/2010 03:33:36 AM
 *       Revision:  none
 *       Compiler:  gcc
 *
 *         Author:  Ivan B. Nikolaev (), I.B.Nikolaev@inp.nsk.su
 *        Company:  Budker Institute of Nuclear Physycs, Novosibirsk, Russia
 *
 * =====================================================================================
 */

#include <boost/filesystem/path.hpp>
#include <boost/filesystem/operations.hpp>
#include <boost/filesystem/exception.hpp>
#include <iostream>
#include <string>
using namespace std;

bool my_fs_name_check(const string & s)
{
  return true;
}

int main()
{
  string s="a:a";
  namespace fs = boost::filesystem;
  try {
    fs::path p(s,&my_fs_name_check);
    cout << s << endl;
    cout << p.string() << endl;
  }
  catch(fs::filesystem_error e) {
    cout << e.what() << endl;
  }
}
// !g++ -lboost_filesystem %
