#include<fstream>
#include<iostream>
#include<sstream>

#include<string>
#include<vector>
#include<valarray>

/* for regular exprations */
#include<sys/types.h>
#include<regex.h>

#include<string.h>
#include<stdio.h>

#include<Opt.h>
#include<measurement/Result.h>
unsigned int version=0;
bool is(istream &is,char Ch)    {
	char c;
	is.get(c);
	if( c == Ch)	{
		is.putback(c);
		return true;
	}
	is.putback(c);
	return false;
}

/* this funtion get version from file steream */
unsigned int get_version(ifstream & f)	{
	const unsigned BUF_SIZE=128; //maximum bufer size
	const unsigned MAX_LINE=128; //masimum amount of lines where I can read version
	char buf[BUF_SIZE]; // temporary bufer for lines from input file 
	char buf2[BUF_SIZE];// char buffer with version
	unsigned int ver=0;
	regex_t preg;
	regmatch_t pmatch[1];
	/* I should pass all string untill find " #  version  : " */
	regcomp(&preg, "^ *# *version *:",REG_ICASE);
	/* read file until regexp matchs or bufend or LINES lines*/
	for(unsigned i=0; i< MAX_LINE && !f.eof() && regexec(&preg,buf,1,pmatch,0);i++ ) f.getline(buf,BUF_SIZE);
	/* safe copy chars from end of match to end of line */	
	strncpy(buf2,&buf[pmatch[0].rm_eo],BUF_SIZE); 
	buf2[BUF_SIZE-1]=0; //protection from loozing null character
	/* read version from buffer */
	sscanf(buf2,"%u",&ver);
	return ver;
}


void get(const char * file_name)	{
	/* try to open file */
	ifstream fdata(file_name);
	if(!fdata) {
	 cerr << "get: Can't open file " << file_name << endl;
	 return;
	}
	cout << "File format version : " <<  get_version(fdata) << endl;
		/*
	double time,delta,delta_err;
	valarray<double> freq(10000);
	for(unsigned long i = 0; !fdata.eof(); i++)  {
		while(is(fdata,'#')) fdata.ignore(1000,'\n');
		fdata >> time >> freq[i] >> delta >> delta_err;
		fdata.ignore(1000,'\n');

		if(time >3200) {
			break;
		};
		graph->SetPoint(i,time,delta);
		graph->SetPointError(i,0,delta_err);

		ostringstream ost;
		ost << freq[i];
		FreqText.push_back(new TText(time,delta,ost.str().c_str()));
		FreqText[i]->SetTextAngle(90);
		FreqText[i]->SetTextSize(0.035);

	};*/

}


int main(int argc, char ** argv) {
	Opt opt;
	opt.add("-h",0);
	opt.add("--help",0);
	opt.add("--usage",0);
	opt.fill(argc,argv);
	if(opt.isopt("--usage"))	{
		cout << "Usage: " << *opt.par.begin() << " file1 [file2 file3 ...] " << endl;
	}
	for(list<string>::iterator p=++opt.par.begin();p!=opt.par.end();p++)	{
		cout << "reading file " << *p << endl;
		get((*p).c_str());
	}
}
