//#=====================================================================================
//#
//#       Filename:  opt_test.cpp
//#
//#    Description:  Is to test class Opt.h and test some features
//#
//#        Version:  1.0
//#        Created:  12.12.2002
//#       Revision:  none
//#       Compiler:  GNU C/C++
//#
//#         Author:  Ivan B. Nikolaev
//#        Company:  BINP,Russia
//#          Email:  I.B.Nikolaev@inp.nsk.su
//#
//#=====================================================================================

#include<iostream>
#include"../Opt.h"
#include"../camac/Module.h"
int main(int argc, char ** argv) { 
	Opt opt("abc:d:efg");
	/*
	opt.add("-a",1);
	opt.add("--ab",1);*/
	opt.add("--noparam",0);
	cout << "--noparam options with 0 param \n";
	opt.add("--oneparam",1);
	cout << "--oneparam options with 1 param\n";
	opt.add("--nparam",3);
	cout << "--nparam options with 3 param \n";
	cerr << "saccesfully add all options " << endl;
	opt.add("--address",1);
	try {
		opt.fill(argc,argv);
		cout << "Option map: " << endl;
		typedef map<string,unsigned>::const_iterator MI;
		for(MI p = opt.pmap.begin(); p!=opt.pmap.end(); p++)	{
			cout << p->first << " : " << p->second << endl;
		}
		cout << "Reseived options: " << endl;
		typedef map<string,vector<string> >::const_iterator MI2;
		for(MI2 p = opt.opt.begin(); p!=opt.opt.end(); p++)	{
			cout << p->first << "(string) : ";
			for(unsigned i=0; i<(p->second).size();i++)	{	
				cout <<  (p->second)[i] << " "  ;
			}
			cout << endl;
			cout << "     (data) : ";
			vector<double> data;
			opt.getopt(p->first,&data);
			for(unsigned i=0; i<data.size();i++)	{	
				cout <<  data[i] << " ";
			}
			cout << endl;
			
		}
		cout << " Reseived parameters: " << endl;
		typedef list<string>::const_iterator LI;
		for(LI p = opt.par.begin(); p!=opt.par.end(); p++)	{
			cout << *p << endl;
		}
		// test for camac::Address 
		string tmp;
		if(opt.getopt("--address",&tmp))	{
			camac::Address a(tmp.c_str());
			cout << " module name = " << a.name << endl;
			cout << " interface = " << a.interface << endl;
			cout << " crate = " << a.crate << endl;
			cout << " station = " << a.station << endl;
			cout << " channel = " << a.channel << endl;	
		}
	}
	catch(Opt::Bad b)	{
		//cerr << "Option " << b.opt << " must have a value \n";
		cerr << "***** option " << b.opt << ": " << b.error << endl; 
	}
	
}
