#include <iostream>
#include <fstream>
#include <iomanip>


#include <boost/program_options.hpp>
#include <boost/program_options/errors.hpp>


using namespace std;

int main(int argc, char ** argv)    {
    namespace po=boost::program_options;
    po::options_description opt_desc("Allowed options");
    opt_desc.add_options()
	("help","Print this help");

    po::variables_map opt;
    try {
	po::store(po::parse_command_line(argc, argv, opt_desc), opt);
	po::notify(opt);

	if (opt.count("help") )
	{
	    cout << opt_desc;
	    return 1;
	}
    }
    catch (boost::program_options::error po_error) {
	cerr << po_error.what() << endl;
    }

    return 0;
}
