#include<iostream>
#include<iomanip>
#include<cstdio>
#include"../Station.h"
#include"../Engine.h"

#include<getopt.h>
//#include"/home/vepp4/Polarimeter/anton/Motor/checkline/engine.h"
//#include"/home/vepp4/Polarimeter/anton/Motor/checkline/engine.c"

int main(int argc, char * const * argv)  {
    int address = -1;
	int steps=0;
    modules::Engine::Status st;
    modules::Engine::Config cfg;
    modules::Engine::Ident id;
	try {
		modules::Port port("/dev/ttyS1",0);
    	int fd = port.Getfd();

		modules::Engine eng(fd);
        address = 1;
        eng.SetAddress(address);

        /*
		writecommand(address,3);
		usleep(500000);
		int rc = read(fd, buff, 10);
        cerr << "rc = " << rc<<endl;
		for(int i =0 ; i <10; i++)  {
            printf("%x ",unsigned(buff[i]));
		}
		printf("\n");
		*/

 	int c;
         int digit_optind = 0;

         while (1)	{
             int this_option_optind = optind ? optind : 1;
             int option_index = 0;
             static struct option long_options[] =
             {
               {"address", 1, 0, 'a'},
               {"ident",0,0, 'i'},
			   {"getx", 0, 0, 'g'},
			   {"get_config",0,0, 'c'},
			   {"move", 1, 0, 'm'},
			   {"setx", 1, 0, 's'},
			   {"status", 0, 0, 't'},
			   {0, 0, 0, 0}
             };

			 //c = getopt_long (argc, argv, "abcm:d:012",long_options, &option_index);
			 c = getopt_long (argc, argv, "a:m",long_options, &option_index);
         	 if (c == -1)	break;

			 switch (c)	{
               case 0:
                 printf ("option %s", long_options[option_index].name);
                 if (optarg)	printf (" with arg %s", optarg);
                 printf ("\n");
                 break;
               case '0':
               case '1':
               case '2':
                 if (digit_optind != 0 && digit_optind != this_option_optind)
                   printf ("digits occur in two different argv-elements.\n");
                 digit_optind = this_option_optind;
                 printf ("option %c\n", c);
                 break;
               case 'a':
                 sscanf(optarg,"%d",&address);
                 eng.SetAddress(address);
				 break;

               case 'b':
                 printf ("option b\n");
                 break;


				 case 'c':
					 cfg  = eng.GetConfig();
                     cerr <<"ura" <<endl;
                 break;

               case 'i':
                   cerr <<"test"<<endl;
				   id = eng.IdentDevice();
			   cout << "Version: " << id.Version << ", Serial number: " << id.SerialNumber <<endl;
			   	break;

			   case 'g':
                    cout << "Coordinate of engine " << eng.GetAddress() << " is " << eng.GetCoordinate() <<endl;
                break;
			   case 'm':
				   sscanf(optarg,"%d",&steps);
				   if(eng.GetAddress() != 0) eng.Move(steps);
                   printf ("Move engine %d on %s steps \n", eng.GetAddress(), optarg);
                break;
				 case 's':
                     	sscanf(optarg,"%d",&steps);
					 	cout << "set coordinate of engine " << eng.GetAddress() << " to " << steps << endl;
				 		eng.SetCoordinate(steps);
                 break;
				 case 't':
                     st = eng.GetStatus();
        			 st.print();
				 break;
				case '?':
                 break;

               default:
                 printf ("?? getopt returned character code 0%o ??\n", c);
               }
            }

         if (optind < argc)
           {
             printf ("non-option ARGV-elements: ");
             while (optind < argc)
             printf ("%s ", argv[optind++]);
             printf ("\n");
           }

	}
	catch(camac::system_error e)  {
        cerr << e.what() <<endl;
	}
	catch(runtime_error e)  {
        cerr << e.what() <<endl;
	}

}

