#pragma once
#include <iostream>
namespace vepp4
{
	class Status 
	{
		public:
			//static const  char * const  file_name="/home/vepp4/vpar/.Status";
			//1 - "ÉÎÖÅËÃÉÑ", 2 - "ÕÓËÏÒÅÎÉÅ", 3 - "ÜËÓÐÅÒÉÍÅÎÔ", 5 - "ÓÔÁÎÄÁÒÔÎÙÊ ÃÉËÌ", 6- "ÉÚÍÅÒÉÔÅÌØÎÙÊ" ÓÔÁÔÕÓ)
			int status; //current status
			time_t status_time;
			double set_energy;
			time_t energy_time; //ËÏÇÄÁ ÉÚÍÅÎÉÌÁÓØ ÜÎÅÒÇÉÑ
			time_t injection_time;
			time_t acceleration_time;
			time_t experiment_time;
			time_t cycle_time;
			time_t measurement_time;
			Status(void);

			void Read(const std::string & fname = "/home/vepp4/vpar/.Status");
			void Write(const std::string &fname = "/home/vepp4/vpar/.Status");
			void Update(void);
			void read(std::istream & is);
			void write(std::ostream &os) const;
	};
}

inline std::istream & operator>>(std::istream & is, vepp4::Status & s )
{
  s.read(is);
  return is;
}

inline std::ostream & operator<<(std::ostream & os, const vepp4::Status & s)
{
  s.write(os);
  return os;
}
